Index: /trunk/SophyaLib/TArray/fioarr.cc
===================================================================
--- /trunk/SophyaLib/TArray/fioarr.cc	(revision 2926)
+++ /trunk/SophyaLib/TArray/fioarr.cc	(revision 2927)
@@ -219,9 +219,9 @@
 // #pragma define_template FIO_TArray<uint_1>
 #pragma define_template FIO_TArray<uint_2>
-// #pragma define_template FIO_TArray<int_2>
+#pragma define_template FIO_TArray<uint_4>
+#pragma define_template FIO_TArray<uint_8>
+#pragma define_template FIO_TArray<int_2>
 #pragma define_template FIO_TArray<int_4>
 #pragma define_template FIO_TArray<int_8>
-// #pragma define_template FIO_TArray<uint_4>
-// #pragma define_template FIO_TArray<uint_8>
 #pragma define_template FIO_TArray<r_8>
 #pragma define_template FIO_TArray<r_4>
@@ -235,9 +235,9 @@
 // template class FIO_TArray<uint_1>;
 template class FIO_TArray<uint_2>;
-// template class FIO_TArray<int_2>;
+template class FIO_TArray<uint_4>;
+template class FIO_TArray<uint_8>;
+template class FIO_TArray<int_2>;
 template class FIO_TArray<int_4>;
 template class FIO_TArray<int_8>;
-// template class FIO_TArray<uint_4>;
-// template class FIO_TArray<uint_8>;
 template class FIO_TArray<r_8>;
 template class FIO_TArray<r_4>;
Index: /trunk/SophyaLib/TArray/tarray.cc
===================================================================
--- /trunk/SophyaLib/TArray/tarray.cc	(revision 2926)
+++ /trunk/SophyaLib/TArray/tarray.cc	(revision 2927)
@@ -1497,9 +1497,9 @@
 /*
 #pragma define_template TArray<uint_1>
+*/
+#pragma define_template TArray<uint_2>
+#pragma define_template TArray<uint_4>
+#pragma define_template TArray<uint_8>
 #pragma define_template TArray<int_2>
-#pragma define_template TArray<uint_4>
-*/
-#pragma define_template TArray<uint_2>
-#pragma define_template TArray<uint_8>
 #pragma define_template TArray<int_4>
 #pragma define_template TArray<int_8>
@@ -1514,9 +1514,9 @@
 /*
 template class TArray<uint_1>; 
+*/
+template class TArray<uint_2>;
+template class TArray<uint_4>;
+template class TArray<uint_8>;
 template class TArray<int_2>;  
-template class TArray<uint_4>;
-*/
-template class TArray<uint_2>;
-template class TArray<uint_8>;
 template class TArray<int_4>;
 template class TArray<int_8>;
Index: /trunk/SophyaLib/TArray/tarrinit.cc
===================================================================
--- /trunk/SophyaLib/TArray/tarrinit.cc	(revision 2926)
+++ /trunk/SophyaLib/TArray/tarrinit.cc	(revision 2927)
@@ -35,6 +35,8 @@
   DObjRegister(FIO_TArray<uint_2>, TVector<uint_2>);
 
-  //  PPRegister(FIO_TArray<int_2>);
-  //  DObjRegister(FIO_TArray<int_2>, TArray<int_2>);
+  PPRegister(FIO_TArray<int_2>);
+  DObjRegister(FIO_TArray<int_2>, TArray<int_2>);
+  DObjRegister(FIO_TArray<int_2>, TMatrix<int_2>);
+  DObjRegister(FIO_TArray<int_2>, TVector<int_2>);
 
   PPRegister(FIO_TArray<int_4>);
@@ -48,8 +50,14 @@
   DObjRegister(FIO_TArray<int_8>, TVector<int_8>);
 
-  //  PPRegister(FIO_TArray<uint_4>);
-  // DObjRegister(FIO_TArray<uint_4>, TArray<uint_4>);
-  //  PPRegister(FIO_TArray<uint_8>);
-  //  DObjRegister(FIO_TArray<uint_8>, TArray<uint_8>);
+  PPRegister(FIO_TArray<uint_4>);
+  DObjRegister(FIO_TArray<uint_4>, TArray<uint_4>);
+  DObjRegister(FIO_TArray<uint_4>, TMatrix<uint_4>);
+  DObjRegister(FIO_TArray<uint_4>, TVector<uint_4>);
+
+  PPRegister(FIO_TArray<uint_8>);
+  DObjRegister(FIO_TArray<uint_8>, TArray<uint_8>);
+  DObjRegister(FIO_TArray<uint_8>, TMatrix<uint_8>);
+  DObjRegister(FIO_TArray<uint_8>, TVector<uint_8>);
+
   PPRegister(FIO_TArray<r_4>);
   DObjRegister(FIO_TArray<r_4>, TArray<r_4>);
Index: /trunk/SophyaLib/TArray/tmatrix.cc
===================================================================
--- /trunk/SophyaLib/TArray/tmatrix.cc	(revision 2926)
+++ /trunk/SophyaLib/TArray/tmatrix.cc	(revision 2927)
@@ -1,3 +1,3 @@
-// $Id: tmatrix.cc,v 1.35 2006-02-23 13:50:26 ansari Exp $
+// $Id: tmatrix.cc,v 1.36 2006-04-03 08:55:26 ansari Exp $
 //                         C.Magneville          04/99
 #include "sopnamsp.h"
@@ -670,5 +670,7 @@
 #ifdef __CXX_PRAGMA_TEMPLATES__
 #pragma define_template TMatrix<uint_2>
+#pragma define_template TMatrix<uint_4>
 #pragma define_template TMatrix<uint_8>
+#pragma define_template TMatrix<int_2>
 #pragma define_template TMatrix<int_4>
 #pragma define_template TMatrix<int_8>
@@ -682,5 +684,7 @@
 namespace SOPHYA {
 template class TMatrix<uint_2>;
+template class TMatrix<uint_4>;
 template class TMatrix<uint_8>;
+template class TMatrix<int_2>;
 template class TMatrix<int_4>;
 template class TMatrix<int_8>;
Index: /trunk/SophyaLib/TArray/tvector.cc
===================================================================
--- /trunk/SophyaLib/TArray/tvector.cc	(revision 2926)
+++ /trunk/SophyaLib/TArray/tvector.cc	(revision 2927)
@@ -1,3 +1,3 @@
-// $Id: tvector.cc,v 1.21 2006-02-22 18:17:30 ansari Exp $
+// $Id: tvector.cc,v 1.22 2006-04-03 08:55:26 ansari Exp $
 //                         C.Magneville          04/99
 #include "sopnamsp.h"
@@ -246,5 +246,7 @@
 #ifdef __CXX_PRAGMA_TEMPLATES__
 #pragma define_template TVector<uint_2>
+#pragma define_template TVector<uint_4>
 #pragma define_template TVector<uint_8>
+#pragma define_template TVector<int_2>
 #pragma define_template TVector<int_4>
 #pragma define_template TVector<int_8>
@@ -258,5 +260,7 @@
 namespace SOPHYA {
 template class TVector<uint_2>;
+template class TVector<uint_4>;
 template class TVector<uint_8>;
+template class TVector<int_2>;
 template class TVector<int_4>;
 template class TVector<int_8>;