Index: trunk/SophyaPI/PIext/nomtarradapter.cc
===================================================================
--- trunk/SophyaPI/PIext/nomtarradapter.cc	(revision 2925)
+++ trunk/SophyaPI/PIext/nomtarradapter.cc	(revision 2930)
@@ -66,46 +66,4 @@
 }
 
-/* --Methode-- */
-template <class T> 
-void NOMAdapter_TArray<T>::ReadFits(string const & flnm)
-{
-  FitsInFile fis(flnm);
-  fis >> (*mArr);
-}
-
-/* --Methode-- */
-template <class T> 
-void NOMAdapter_TArray<T>::SaveFits(string const & flnm)
-{
-  FitsOutFile fos(flnm);
-  fos << (*mArr);
-}
-
-// ---- Specialisation pour complexes -----
-DECL_TEMP_SPEC  /* equivalent a template <> , pour SGI-CC en particulier */
-void NOMAdapter_TArray< complex<r_4> >::ReadFits(string const & flnm)
-{
-cout << " NOMAdapter_TArray< complex<r_4> >::ReadFits() - Error " 
-     << " Not supported (complex data type)" << endl;
-}
-DECL_TEMP_SPEC  /* equivalent a template <> , pour SGI-CC en particulier */
-void NOMAdapter_TArray< complex<r_4> >::SaveFits(string const & flnm)
-{
-cout << " NOMAdapter_TArray< complex<r_4> >::SaveFits() - Error " 
-     << " Not supported (complex data type)" << endl;
-}
-
-DECL_TEMP_SPEC  /* equivalent a template <> , pour SGI-CC en particulier */
-void NOMAdapter_TArray< complex<r_8> >::ReadFits(string const & flnm)
-{
-cout << " NOMAdapter_TArray< complex<r_8> >::ReadFits() - Error " 
-     << " Not supported (complex data type)" << endl;
-}
-DECL_TEMP_SPEC  /* equivalent a template <> , pour SGI-CC en particulier */
-void NOMAdapter_TArray< complex<r_8> >::SaveFits(string const & flnm)
-{
-cout << " NOMAdapter_TArray< complex<r_8> >::SaveFits() - Error " 
-     << " Not supported (complex data type)" << endl;
-}
 
 /* --Methode-- */
@@ -268,14 +226,16 @@
 
 #ifdef __CXX_PRAGMA_TEMPLATES__
-//#pragma define_template NOMAdapter_TArray<uint_2>
-//#pragma define_template NOMAdapter_TArray<int_2>
+#pragma define_template NOMAdapter_TArray<uint_2>
+#pragma define_template NOMAdapter_TArray<int_2>
 #pragma define_template NOMAdapter_TArray<int_4>
+#pragma define_template NOMAdapter_TArray<int_8>
 #pragma define_template NOMAdapter_TArray<r_4>
 #pragma define_template NOMAdapter_TArray<r_8>
 #pragma define_template NOMAdapter_TArray< complex<r_4> >
 #pragma define_template NOMAdapter_TArray< complex<r_8> >
-//#pragma define_template NTupInt_TArray<uint_2>
-//#pragma define_template NTupInt_TArray<int_2>
+#pragma define_template NTupInt_TArray<uint_2>
+#pragma define_template NTupInt_TArray<int_2>
 #pragma define_template NTupInt_TArray<int_4>
+#pragma define_template NTupInt_TArray<int_8>
 #pragma define_template NTupInt_TArray<r_4>
 #pragma define_template NTupInt_TArray<r_8>
@@ -285,14 +245,16 @@
 
 #if defined(ANSI_TEMPLATES) 
-//template class NOMAdapter_TArray<uint_2>;
-//template class NOMAdapter_TArray<int_2>;
+template class NOMAdapter_TArray<uint_2>;
+template class NOMAdapter_TArray<int_2>;
 template class NOMAdapter_TArray<int_4>;
+template class NOMAdapter_TArray<int_8>;
 template class NOMAdapter_TArray<r_4>;
 template class NOMAdapter_TArray<r_8>;
 template class NOMAdapter_TArray< complex<r_4> >;
 template class NOMAdapter_TArray< complex<r_8> >;
-// template class NTupInt_TArray<uint_2>;
-// template class NTupInt_TArray<int_2>;
+template class NTupInt_TArray<uint_2>;
+template class NTupInt_TArray<int_2>;
 template class NTupInt_TArray<int_4>;
+template class NTupInt_TArray<int_8>;
 template class NTupInt_TArray<r_4>;
 template class NTupInt_TArray<r_8>;
Index: trunk/SophyaPI/PIext/nomtarradapter.h
===================================================================
--- trunk/SophyaPI/PIext/nomtarradapter.h	(revision 2925)
+++ trunk/SophyaPI/PIext/nomtarradapter.h	(revision 2930)
@@ -27,6 +27,4 @@
   virtual AnyDataObj*		CloneDataObj(bool share=false);
 
-  virtual void			ReadFits(string const & flnm);
-  virtual void			SaveFits(string const & flnm);
   virtual void			SavePPF(POutPersist& s, string const & nom);
 
Index: trunk/SophyaPI/PIext/nomtmatvecadapter.cc
===================================================================
--- trunk/SophyaPI/PIext/nomtmatvecadapter.cc	(revision 2925)
+++ trunk/SophyaPI/PIext/nomtmatvecadapter.cc	(revision 2930)
@@ -72,45 +72,4 @@
 }
 
-/* --Methode-- */
-template <class T> 
-void NOMAdapter_TMatrix<T>::ReadFits(string const & flnm)
-{
-  FitsInFile fis(flnm);
-  fis >> (*mMtx);
-}
-
-/* --Methode-- */
-template <class T> 
-void NOMAdapter_TMatrix<T>::SaveFits(string const & flnm)
-{
-  FitsOutFile fos(flnm);
-  fos << (*mMtx);
-}
-// ---- Specialisation pour complexes -----
-DECL_TEMP_SPEC  /* equivalent a template <> , pour SGI-CC en particulier */
-void NOMAdapter_TMatrix< complex<r_4> >::ReadFits(string const & flnm)
-{
-cout << " NOMAdapter_TMatrix< complex<r_4> >::ReadFits() - Error " 
-     << " Not supported (complex data type)" << endl;
-}
-DECL_TEMP_SPEC  /* equivalent a template <> , pour SGI-CC en particulier */
-void NOMAdapter_TMatrix< complex<r_4> >::SaveFits(string const & flnm)
-{
-cout << " NOMAdapter_TMatrix< complex<r_4> >::SaveFits() - Error " 
-     << " Not supported (complex data type)" << endl;
-}
-
-DECL_TEMP_SPEC  /* equivalent a template <> , pour SGI-CC en particulier */
-void NOMAdapter_TMatrix< complex<r_8> >::ReadFits(string const & flnm)
-{
-cout << " NOMAdapter_TMatrix< complex<r_8> >::ReadFits() - Error " 
-     << " Not supported (complex data type)" << endl;
-}
-DECL_TEMP_SPEC  /* equivalent a template <> , pour SGI-CC en particulier */
-void NOMAdapter_TMatrix< complex<r_8> >::SaveFits(string const & flnm)
-{
-cout << " NOMAdapter_TMatrix< complex<r_8> >::SaveFits() - Error " 
-     << " Not supported (complex data type)" << endl;
-}
 
 /* --Methode-- */
@@ -390,14 +349,16 @@
 
 #ifdef __CXX_PRAGMA_TEMPLATES__
-//#pragma define_template NOMAdapter_TMatrix<uint_2>
-//#pragma define_template NOMAdapter_TMatrix<int_2>
+#pragma define_template NOMAdapter_TMatrix<uint_2>
+#pragma define_template NOMAdapter_TMatrix<int_2>
 #pragma define_template NOMAdapter_TMatrix<int_4>
+#pragma define_template NOMAdapter_TMatrix<int_8>
 #pragma define_template NOMAdapter_TMatrix<r_4>
 #pragma define_template NOMAdapter_TMatrix<r_8>
 #pragma define_template NOMAdapter_TMatrix< complex<r_4> >
 #pragma define_template NOMAdapter_TMatrix< complex<r_8> >
-//#pragma define_template NTupInt_TMatrix<uint_2>
-//#pragma define_template NTupInt_TMatrix<int_2>
+#pragma define_template NTupInt_TMatrix<uint_2>
+#pragma define_template NTupInt_TMatrix<int_2>
 #pragma define_template NTupInt_TMatrix<int_4>
+#pragma define_template NTupInt_TMatrix<int_8>
 #pragma define_template NTupInt_TMatrix<r_4>
 #pragma define_template NTupInt_TMatrix<r_8>
@@ -407,14 +368,16 @@
 
 #if defined(ANSI_TEMPLATES) 
-//template class NOMAdapter_TMatrix<uint_2>;
-//template class NOMAdapter_TMatrix<int_2>;
+template class NOMAdapter_TMatrix<uint_2>;
+template class NOMAdapter_TMatrix<int_2>;
 template class NOMAdapter_TMatrix<int_4>;
+template class NOMAdapter_TMatrix<int_8>;
 template class NOMAdapter_TMatrix<r_4>;
 template class NOMAdapter_TMatrix<r_8>;
 template class NOMAdapter_TMatrix< complex<r_4> >;
 template class NOMAdapter_TMatrix< complex<r_8> >;
-// template class NTupInt_TMatrix<uint_2>;
-// template class NTupInt_TMatrix<int_2>;
+template class NTupInt_TMatrix<uint_2>;
+template class NTupInt_TMatrix<int_2>;
 template class NTupInt_TMatrix<int_4>;
+template class NTupInt_TMatrix<int_8>;
 template class NTupInt_TMatrix<r_4>;
 template class NTupInt_TMatrix<r_8>;
Index: trunk/SophyaPI/PIext/nomtmatvecadapter.h
===================================================================
--- trunk/SophyaPI/PIext/nomtmatvecadapter.h	(revision 2925)
+++ trunk/SophyaPI/PIext/nomtmatvecadapter.h	(revision 2930)
@@ -28,6 +28,4 @@
   virtual AnyDataObj*		CloneDataObj(bool share=false);
 
-  virtual void			ReadFits(string const & flnm);
-  virtual void			SaveFits(string const & flnm);
   virtual void			SavePPF(POutPersist& s, string const & nom);
 
Index: trunk/SophyaPI/PIext/piinit.cc
===================================================================
--- trunk/SophyaPI/PIext/piinit.cc	(revision 2925)
+++ trunk/SophyaPI/PIext/piinit.cc	(revision 2930)
@@ -64,5 +64,8 @@
   serv->RegisterClass(new Matrix, new NOMAdapter_Matrix );
 #else
+  serv->RegisterClass(new TArray<uint_2>, new NOMAdapter_TArray<uint_2> );
+  serv->RegisterClass(new TArray<int_2>, new NOMAdapter_TArray<int_2> );
   serv->RegisterClass(new TArray<int_4>, new NOMAdapter_TArray<int_4> );
+  serv->RegisterClass(new TArray<int_8>, new NOMAdapter_TArray<int_8> );
   serv->RegisterClass(new TArray<r_4>, new NOMAdapter_TArray<r_4> );
   serv->RegisterClass(new TArray<r_8>, new NOMAdapter_TArray<r_8> );
@@ -70,6 +73,12 @@
   serv->RegisterClass(new TArray<complex<r_8> >, new NOMAdapter_TArray<complex<r_8> > );
 
+  serv->RegisterClass(new TVector<uint_2>, new NOMAdapter_TMatrix<uint_2> );
+  serv->RegisterClass(new TMatrix<uint_2>, new NOMAdapter_TMatrix<uint_2> );
+  serv->RegisterClass(new TVector<int_2>, new NOMAdapter_TMatrix<int_2> );
+  serv->RegisterClass(new TMatrix<int_2>, new NOMAdapter_TMatrix<int_2> );
   serv->RegisterClass(new TVector<int_4>, new NOMAdapter_TMatrix<int_4> );
   serv->RegisterClass(new TMatrix<int_4>, new NOMAdapter_TMatrix<int_4> );
+  serv->RegisterClass(new TVector<int_8>, new NOMAdapter_TMatrix<int_8> );
+  serv->RegisterClass(new TMatrix<int_8>, new NOMAdapter_TMatrix<int_8> );
   serv->RegisterClass(new TVector<r_4>, new NOMAdapter_TMatrix<r_4> );
   serv->RegisterClass(new TMatrix<r_4>, new NOMAdapter_TMatrix<r_4> );
Index: trunk/SophyaPI/PIext/pitvmaad.cc
===================================================================
--- trunk/SophyaPI/PIext/pitvmaad.cc	(revision 2925)
+++ trunk/SophyaPI/PIext/pitvmaad.cc	(revision 2930)
@@ -91,4 +91,6 @@
 
 #ifdef __CXX_PRAGMA_TEMPLATES__
+#pragma define_template POTVectorAdapter< uint_2 >
+#pragma define_template POTVectorAdapter< int_2 >
 #pragma define_template POTVectorAdapter< int_4 >
 #pragma define_template POTVectorAdapter< int_8 >
@@ -98,4 +100,6 @@
 #pragma define_template POTVectorAdapter< complex<double> > 
 
+#pragma define_template POTMatrixAdapter< uint_2 >
+#pragma define_template POTMatrixAdapter< int_2 >
 #pragma define_template POTMatrixAdapter< int_4 >
 #pragma define_template POTMatrixAdapter< int_8 >
@@ -107,4 +111,6 @@
 
 #if defined(ANSI_TEMPLATES)
+template class POTVectorAdapter< uint_2 >;
+template class POTVectorAdapter< int_2 >;
 template class POTVectorAdapter< int_4 >;
 template class POTVectorAdapter< int_8 >;
@@ -114,4 +120,6 @@
 template class POTVectorAdapter< complex<double> >;
 
+template class POTMatrixAdapter< uint_2 >;
+template class POTMatrixAdapter< int_2 >;
 template class POTMatrixAdapter< int_4 >;
 template class POTMatrixAdapter< int_8 >;