Index: /trunk/SophyaPI/PIext/basexecut.cc
===================================================================
--- /trunk/SophyaPI/PIext/basexecut.cc	(revision 2943)
+++ /trunk/SophyaPI/PIext/basexecut.cc	(revision 2944)
@@ -109,4 +109,5 @@
     tokens.erase(tokens.begin());
     fuf(tokens);
+    return(0);
   }
   catch ( PThrowable & exc ) {
@@ -114,10 +115,10 @@
 	 << (string)typeid(exc).name() << " Msg= " 
 	 << exc.Msg() << endl;
-    cout << endl; 
+    return(-77);
   }
   catch ( ... ) {
     cerr << "\n PIABaseExecutor: Call / Catched Exception ... " 
 	 << endl;
-    cout << endl; 
+    return(-79);
   }
 #endif
Index: /trunk/SophyaPI/PIext/cxxexecutor.cc
===================================================================
--- /trunk/SophyaPI/PIext/cxxexecutor.cc	(revision 2943)
+++ /trunk/SophyaPI/PIext/cxxexecutor.cc	(revision 2944)
@@ -158,5 +158,5 @@
   ZSync zs(mutx_cxxe);  zs.NOp(); 
 
-  rc = ExecuteCXX(toks); if(rc) return(1);
+  return ( ExecuteCXX(toks) ); 
 
 } else if(kw == "c++execfrf") {
@@ -172,8 +172,9 @@
     else              rc = FillUserFctFrF();
   if(rc) return(1);
-  rc = CrFile();   if(rc) return(1);
-  rc = Compile();  if(rc) return(1);
-  rc = Link();     if(rc) return(1);
-  rc = Call();     if(rc) return(1);
+  rc = CrFile();   if(rc) return(rc);
+  rc = Compile();  if(rc) return(rc);
+  rc = Link();     if(rc) return(rc);
+  rc = Call();     
+  return(rc);
 
 } else if(kw == "c++args") {
@@ -190,7 +191,8 @@
   ZSync zs(mutx_cxxe);  zs.NOp(); 
 
-  rc = FillUserCode(toks,2);        if(rc) return(1);
-  rc = FillUserFctFrS();            if(rc) return(1);
-  rc = CrFile(tokens[0],tokens[1]); if(rc) return(1);
+  rc = FillUserCode(toks,2);        if(rc) return(rc);
+  rc = FillUserFctFrS();            if(rc) return(rc);
+  rc = CrFile(tokens[0],tokens[1]); 
+  return(1);
 
 } else if(kw == "c++createfrf") {
@@ -206,5 +208,6 @@
     else              rc = FillUserFctFrF(tokens[3]);
   if(rc) return(1);
-  rc = CrFile(tokens[0],tokens[1]); if(rc) return(1);
+  rc = CrFile(tokens[0],tokens[1]); 
+  return rc;
 
 } else if(kw == "c++compile") {
@@ -214,5 +217,5 @@
   if(tokens.size()>=1) rc = Compile(tokens[0]);
   else                 rc = Compile();
-  if(rc) return(1);
+  return(rc);
 
 } else if(kw == "c++link") {
@@ -223,5 +226,5 @@
   else if(tokens.size()>=1) rc = Link(tokens[0]);
   else                      rc = Link();
-  if(rc) return(1);
+  return(rc);
 
 } else if(kw == "c++include") {
@@ -295,10 +298,10 @@
 {
 int rc=0;
-rc = FillUserCode(usercode,0); if(rc) return(1);
-rc = FillUserFctFrS(userfct);  if(rc) return(1);
-rc = CrFile();   if(rc) return(1);
-rc = Compile();  if(rc) return(1);
-rc = Link();     if(rc) return(1);
-rc = Call();     if(rc) return(1);
+rc = FillUserCode(usercode,0); if(rc) return(rc);
+rc = FillUserFctFrS(userfct);  if(rc) return(rc);
+rc = CrFile();   if(rc) return(rc);
+rc = Compile();  if(rc) return(rc);
+rc = Link();     if(rc) return(rc);
+rc = Call();     if(rc) return(rc);
 return 0;
 }
@@ -726,5 +729,5 @@
 if(mPrtLevel>1) cout<<"Link from "<<libname<<" for function "<<func
                   <<" (rc="<<rc<<")"<<endl;
-return 0;
+return rc;
 }
 
@@ -742,6 +745,5 @@
 if(mCallArgs.size()>0)
   for(uint_4 i=0;i<mCallArgs.size();i++) arg.push_back(mCallArgs[i]);
-mpiac->ExecuteCommand(key,arg,toks);
-return 0;
+return ( mpiac->ExecuteCommand(key,arg,toks) );
 }
 
Index: /trunk/SophyaPI/PIext/pistdimgapp.cc
===================================================================
--- /trunk/SophyaPI/PIext/pistdimgapp.cc	(revision 2943)
+++ /trunk/SophyaPI/PIext/pistdimgapp.cc	(revision 2944)
@@ -93,6 +93,6 @@
 
 /* --Methode-- */
-PIStdImgApp::PIStdImgApp(int narg, char* arg[])
-  : PIApplication(420, 320, narg, arg) , resusg(ResourceUsage::RU_All)
+PIStdImgApp::PIStdImgApp(bool fgsmall, int narg, char* arg[])
+  : PIApplication(420, (fgsmall)?320:220, narg, arg) , resusg(ResourceUsage::RU_All)
 {
 
@@ -186,4 +186,10 @@
 int msx = 420+mFgScSz*60;
 int msy = 320+mFgScSz*40;
+int sfgsz = mFgScSz;
+if (fgsmall) {  // Flag petite taille de fenetre 
+  if (mFgScSz > 1) mFgScSz = 1;
+  msx = 420+mFgScSz*40;
+  msy = 220+mFgScSz*20;
+}
 MainWin()->SetSize(msx, msy);
 
@@ -252,4 +258,6 @@
 redirecout = false;
 // RedirectStdOutErr(true);  pas par defaut 
+
+mFgScSz = sfgsz;
  
 mObjMgr = new NamedObjMgr(true);
@@ -1693,5 +1701,6 @@
 PeidaConfigureSignalhandling(fgfpe, fgsegv, true, true);  
 #else
-SophyaConfigureSignalhandling(fgfpe, fgsegv, true, true);  
+// On active aussi SIGUSR1 pour stopthr
+SophyaConfigureSignalhandling(fgfpe, fgsegv, true, true, true);  
 #endif
 m[5]->SetStateMsg(10603, fgfpe);
Index: /trunk/SophyaPI/PIext/pistdimgapp.h
===================================================================
--- /trunk/SophyaPI/PIext/pistdimgapp.h	(revision 2943)
+++ /trunk/SophyaPI/PIext/pistdimgapp.h	(revision 2944)
@@ -46,5 +46,5 @@
 class PIStdImgApp : public PIApplication  {
 public:
-     PIStdImgApp(int narg=0, char* arg[]=NULL);
+     PIStdImgApp(bool fgsmall=false, int narg=0, char* arg[]=NULL);
      ~PIStdImgApp();
 