Index: /trunk/SophyaPI/ProgPI/smakefile_wgrdl
===================================================================
--- /trunk/SophyaPI/ProgPI/smakefile_wgrdl	(revision 2953)
+++ /trunk/SophyaPI/ProgPI/smakefile_wgrdl	(revision 2953)
@@ -0,0 +1,615 @@
+include $(SOPHYABASE)/include/sophyamake.inc
+
+#####  makefile to build piapp linked with GNU readline library 
+#####   
+PROGS = $(SOPHYAEXEP)spiapp
+ 
+all: $(PROGS)
+ 
+clean:
+	rm -f $(PROGS)
+	rm -f $(SOPHYAOBJP)piapp.o $(SOPHYAOBJP)piacmdrdr.o $(SOPHYAOBJP)sopiamodule.o $(SOPHYAOBJP)fitsbtadapter.o $(SOPHYAOBJP)w2ps.o $(SOPHYAOBJP)skymapmodule.o
+ 
+### GNU-readline : libray path and name (-lreadline -lhistory)
+spiapp: $(SOPHYAEXEP)spiapp
+	echo $@ " done"
+$(SOPHYAEXEP)spiapp: $(SOPHYAOBJP)piapp.o $(SOPHYAOBJP)piacmdrdr.o $(SOPHYAOBJP)sopiamodule.o $(SOPHYAOBJP)fitsbtadapter.o $(SOPHYAOBJP)w2ps.o $(SOPHYAOBJP)skymapmodule.o
+	$(CXXLINK) $(CXXTEMPFLG) -o $@ $(SOPHYAOBJP)piapp.o $(SOPHYAOBJP)piacmdrdr.o $(SOPHYAOBJP)sopiamodule.o $(SOPHYAOBJP)fitsbtadapter.o $(SOPHYAOBJP)w2ps.o $(SOPHYAOBJP)skymapmodule.o $(SOPHYAALLSLBLIST) -L/usr/local/lib -lreadline -lhistory -lcurses
+ 
+$(SOPHYAOBJP)fitsbtadapter.o: fitsbtadapter.cc \
+  $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)nobjmgr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)dlftypes.h \
+  $(SOPHYAINCP)servnobjm.h \
+  $(SOPHYAINCP)pdlmgr.h \
+  $(SOPHYAINCP)zthread.h \
+  $(SOPHYAINCP)nomgadapter.h \
+  $(SOPHYAINCP)pidrawer.h \
+  $(SOPHYAINCP)pibwdggen.h \
+  $(SOPHYAINCP)pisysdep.h \
+  $(SOPHYAINCP)piwdgx.h \
+  $(SOPHYAINCP)piwdggen.h \
+  $(SOPHYAINCP)pimsghandler.h \
+  $(SOPHYAINCP)picolist.h \
+  $(SOPHYAINCP)picmap.h \
+  $(SOPHYAINCP)picmapx.h \
+  $(SOPHYAINCP)picmapgen.h \
+  $(SOPHYAINCP)pigraphx.h \
+  $(SOPHYAINCP)pigraphgen.h \
+  $(SOPHYAINCP)pifontx.h \
+  $(SOPHYAINCP)pifontgen.h \
+  $(SOPHYAINCP)pigrcoord.h \
+  $(SOPHYAINCP)pilineatt.h \
+  $(SOPHYAINCP)pigraphuc.h \
+  $(SOPHYAINCP)pievthandler.h \
+  $(SOPHYAINCP)psfile.h \
+  $(SOPHYAINCP)pigratt.h \
+  $(SOPHYAINCP)piaxes.h \
+  $(SOPHYAINCP)parradapter.h \
+  $(SOPHYAINCP)lut.h \
+  $(SOPHYAINCP)ntupintf.h \
+  $(SOPHYAINCP)generalfit.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)generaldata.h \
+  $(SOPHYAINCP)poly.h \
+  $(SOPHYAINCP)peida.h \
+  $(SOPHYAINCP)utils.h \
+  $(SOPHYAINCP)perrors.h \
+  $(SOPHYAINCP)fmath.h \
+  $(SOPHYAINCP)pistdimgapp.h \
+  $(SOPHYAINCP)piapplx.h \
+  $(SOPHYAINCP)piapplgen.h \
+  $(SOPHYAINCP)picontainerx.h \
+  $(SOPHYAINCP)picontainergen.h \
+  $(SOPHYAINCP)pimenubarx.h \
+  $(SOPHYAINCP)pimenubargen.h \
+  $(SOPHYAINCP)pimenux.h \
+  $(SOPHYAINCP)pimenugen.h \
+  $(SOPHYAINCP)picons.h \
+  $(SOPHYAINCP)pistdwdgx.h \
+  $(SOPHYAINCP)pistdwdggen.h \
+  $(SOPHYAINCP)pibwdgx.h \
+  $(SOPHYAINCP)pigraphps.h \
+  $(SOPHYAINCP)piwindowx.h \
+  $(SOPHYAINCP)piwindowgen.h \
+  $(SOPHYAINCP)pioptmenux.h \
+  $(SOPHYAINCP)pioptmenugen.h \
+  $(SOPHYAINCP)pifilechox.h \
+  $(SOPHYAINCP)pifilechogen.h \
+  $(SOPHYAINCP)piperiodx.h \
+  $(SOPHYAINCP)periodic.h \
+  $(SOPHYAINCP)piimage.h \
+  $(SOPHYAINCP)pieldrw.h \
+  $(SOPHYAINCP)pipixmapx.h \
+  $(SOPHYAINCP)pipixmapgen.h \
+  $(SOPHYAINCP)picmapview.h \
+  $(SOPHYAINCP)pi3dwdg.h \
+  $(SOPHYAINCP)pi3ddrw.h \
+  $(SOPHYAINCP)pigraph3d.h \
+  $(SOPHYAINCP)piacmd.h \
+  $(SOPHYAINCP)commander.h \
+  $(SOPHYAINCP)ctimer.h \
+  $(SOPHYAINCP)pisiadw.h \
+  $(SOPHYAINCP)pilistx.h \
+  $(SOPHYAINCP)pilistgen.h \
+  $(SOPHYAINCP)pistzwin.h \
+  $(SOPHYAINCP)pitherm.h \
+  $(SOPHYAINCP)resusage.h \
+  $(SOPHYAINCP)fbtntintf.h \
+  $(SOPHYAINCP)FitsIO/fitsio.h \
+  $(SOPHYAINCP)FitsIO/longnam.h \
+  $(SOPHYAINCP)fitsmanager.h \
+  $(SOPHYAINCP)fitsinoutfile.h \
+  $(SOPHYAINCP)fitshandler.h \
+  $(SOPHYAINCP)fiosinit.h \
+  $(SOPHYAINCP)sophyainit.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  fitsbtadapter.cc
+ 
+### GNU-readline : flag WITH_GNUREADLINE and include file path readline/readline.h readline/history.h
+$(SOPHYAOBJP)piacmdrdr.o: piacmdrdr.cc \
+  $(SOPHYAINCP)sopnamsp.h piacmdrdr.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)zthread.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)pistdimgapp.h \
+  $(SOPHYAINCP)pisysdep.h \
+  $(SOPHYAINCP)piapplx.h \
+  $(SOPHYAINCP)piapplgen.h \
+  $(SOPHYAINCP)pimsghandler.h \
+  $(SOPHYAINCP)picontainerx.h \
+  $(SOPHYAINCP)picontainergen.h \
+  $(SOPHYAINCP)piwdgx.h \
+  $(SOPHYAINCP)piwdggen.h \
+  $(SOPHYAINCP)picolist.h \
+  $(SOPHYAINCP)pimenubarx.h \
+  $(SOPHYAINCP)pimenubargen.h \
+  $(SOPHYAINCP)pimenux.h \
+  $(SOPHYAINCP)pimenugen.h \
+  $(SOPHYAINCP)picons.h \
+  $(SOPHYAINCP)pistdwdgx.h \
+  $(SOPHYAINCP)pistdwdggen.h \
+  $(SOPHYAINCP)pibwdgx.h \
+  $(SOPHYAINCP)pibwdggen.h \
+  $(SOPHYAINCP)picmap.h \
+  $(SOPHYAINCP)picmapx.h \
+  $(SOPHYAINCP)picmapgen.h \
+  $(SOPHYAINCP)pigraphx.h \
+  $(SOPHYAINCP)pigraphgen.h \
+  $(SOPHYAINCP)pifontx.h \
+  $(SOPHYAINCP)pifontgen.h \
+  $(SOPHYAINCP)pigrcoord.h \
+  $(SOPHYAINCP)pilineatt.h \
+  $(SOPHYAINCP)pigraphuc.h \
+  $(SOPHYAINCP)pievthandler.h \
+  $(SOPHYAINCP)psfile.h \
+  $(SOPHYAINCP)pigraphps.h \
+  $(SOPHYAINCP)piwindowx.h \
+  $(SOPHYAINCP)piwindowgen.h \
+  $(SOPHYAINCP)pioptmenux.h \
+  $(SOPHYAINCP)pioptmenugen.h \
+  $(SOPHYAINCP)pifilechox.h \
+  $(SOPHYAINCP)pifilechogen.h \
+  $(SOPHYAINCP)piperiodx.h \
+  $(SOPHYAINCP)periodic.h \
+  $(SOPHYAINCP)piimage.h \
+  $(SOPHYAINCP)parradapter.h \
+  $(SOPHYAINCP)lut.h \
+  $(SOPHYAINCP)pieldrw.h \
+  $(SOPHYAINCP)pidrawer.h \
+  $(SOPHYAINCP)pigratt.h \
+  $(SOPHYAINCP)piaxes.h \
+  $(SOPHYAINCP)pipixmapx.h \
+  $(SOPHYAINCP)pipixmapgen.h \
+  $(SOPHYAINCP)picmapview.h \
+  $(SOPHYAINCP)pi3dwdg.h \
+  $(SOPHYAINCP)pi3ddrw.h \
+  $(SOPHYAINCP)pigraph3d.h \
+  $(SOPHYAINCP)nobjmgr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)dlftypes.h \
+  $(SOPHYAINCP)piacmd.h \
+  $(SOPHYAINCP)commander.h \
+  $(SOPHYAINCP)pdlmgr.h \
+  $(SOPHYAINCP)ctimer.h \
+  $(SOPHYAINCP)pisiadw.h \
+  $(SOPHYAINCP)pilistx.h \
+  $(SOPHYAINCP)pilistgen.h \
+  $(SOPHYAINCP)pistzwin.h \
+  $(SOPHYAINCP)pitherm.h \
+  $(SOPHYAINCP)resusage.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -I/usr/local/include -DWITH_GNUREADLINE -o $@  piacmdrdr.cc
+ 
+$(SOPHYAOBJP)piapp.o: piapp.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)pistdimgapp.h \
+  $(SOPHYAINCP)pisysdep.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)piapplx.h \
+  $(SOPHYAINCP)piapplgen.h \
+  $(SOPHYAINCP)pimsghandler.h \
+  $(SOPHYAINCP)picontainerx.h \
+  $(SOPHYAINCP)picontainergen.h \
+  $(SOPHYAINCP)piwdgx.h \
+  $(SOPHYAINCP)piwdggen.h \
+  $(SOPHYAINCP)picolist.h \
+  $(SOPHYAINCP)pimenubarx.h \
+  $(SOPHYAINCP)pimenubargen.h \
+  $(SOPHYAINCP)pimenux.h \
+  $(SOPHYAINCP)pimenugen.h \
+  $(SOPHYAINCP)picons.h \
+  $(SOPHYAINCP)pistdwdgx.h \
+  $(SOPHYAINCP)pistdwdggen.h \
+  $(SOPHYAINCP)pibwdgx.h \
+  $(SOPHYAINCP)pibwdggen.h \
+  $(SOPHYAINCP)picmap.h \
+  $(SOPHYAINCP)picmapx.h \
+  $(SOPHYAINCP)picmapgen.h \
+  $(SOPHYAINCP)pigraphx.h \
+  $(SOPHYAINCP)pigraphgen.h \
+  $(SOPHYAINCP)pifontx.h \
+  $(SOPHYAINCP)pifontgen.h \
+  $(SOPHYAINCP)pigrcoord.h \
+  $(SOPHYAINCP)pilineatt.h \
+  $(SOPHYAINCP)pigraphuc.h \
+  $(SOPHYAINCP)pievthandler.h \
+  $(SOPHYAINCP)psfile.h \
+  $(SOPHYAINCP)pigraphps.h \
+  $(SOPHYAINCP)piwindowx.h \
+  $(SOPHYAINCP)piwindowgen.h \
+  $(SOPHYAINCP)pioptmenux.h \
+  $(SOPHYAINCP)pioptmenugen.h \
+  $(SOPHYAINCP)pifilechox.h \
+  $(SOPHYAINCP)pifilechogen.h \
+  $(SOPHYAINCP)piperiodx.h \
+  $(SOPHYAINCP)periodic.h \
+  $(SOPHYAINCP)piimage.h \
+  $(SOPHYAINCP)parradapter.h \
+  $(SOPHYAINCP)lut.h \
+  $(SOPHYAINCP)pieldrw.h \
+  $(SOPHYAINCP)pidrawer.h \
+  $(SOPHYAINCP)pigratt.h \
+  $(SOPHYAINCP)piaxes.h \
+  $(SOPHYAINCP)pipixmapx.h \
+  $(SOPHYAINCP)pipixmapgen.h \
+  $(SOPHYAINCP)picmapview.h \
+  $(SOPHYAINCP)pi3dwdg.h \
+  $(SOPHYAINCP)pi3ddrw.h \
+  $(SOPHYAINCP)pigraph3d.h \
+  $(SOPHYAINCP)nobjmgr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)dlftypes.h \
+  $(SOPHYAINCP)piacmd.h \
+  $(SOPHYAINCP)commander.h \
+  $(SOPHYAINCP)pdlmgr.h \
+  $(SOPHYAINCP)ctimer.h \
+  $(SOPHYAINCP)zthread.h \
+  $(SOPHYAINCP)pisiadw.h \
+  $(SOPHYAINCP)pilistx.h \
+  $(SOPHYAINCP)pilistgen.h \
+  $(SOPHYAINCP)pistzwin.h \
+  $(SOPHYAINCP)pitherm.h \
+  $(SOPHYAINCP)resusage.h piacmdrdr.h \
+  $(SOPHYAINCP)piversion.h \
+  $(SOPHYAINCP)piaversion.h \
+  $(SOPHYAINCP)timing.h \
+  $(SOPHYAINCP)skyinit.h \
+  $(SOPHYAINCP)ntoolsinit.h \
+  $(SOPHYAINCP)tarrinit.h \
+  $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)xntuple.h \
+  $(SOPHYAINCP)ntupintf.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  piapp.cc
+ 
+$(SOPHYAOBJP)skymapmodule.o: skymapmodule.cc \
+  $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)piacmd.h \
+  $(SOPHYAINCP)commander.h \
+  $(SOPHYAINCP)pdlmgr.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)ctimer.h \
+  $(SOPHYAINCP)zthread.h \
+  $(SOPHYAINCP)dlftypes.h \
+  $(SOPHYAINCP)nobjmgr.h \
+  $(SOPHYAINCP)pistdimgapp.h \
+  $(SOPHYAINCP)pisysdep.h \
+  $(SOPHYAINCP)piapplx.h \
+  $(SOPHYAINCP)piapplgen.h \
+  $(SOPHYAINCP)pimsghandler.h \
+  $(SOPHYAINCP)picontainerx.h \
+  $(SOPHYAINCP)picontainergen.h \
+  $(SOPHYAINCP)piwdgx.h \
+  $(SOPHYAINCP)piwdggen.h \
+  $(SOPHYAINCP)picolist.h \
+  $(SOPHYAINCP)pimenubarx.h \
+  $(SOPHYAINCP)pimenubargen.h \
+  $(SOPHYAINCP)pimenux.h \
+  $(SOPHYAINCP)pimenugen.h \
+  $(SOPHYAINCP)picons.h \
+  $(SOPHYAINCP)pistdwdgx.h \
+  $(SOPHYAINCP)pistdwdggen.h \
+  $(SOPHYAINCP)pibwdgx.h \
+  $(SOPHYAINCP)pibwdggen.h \
+  $(SOPHYAINCP)picmap.h \
+  $(SOPHYAINCP)picmapx.h \
+  $(SOPHYAINCP)picmapgen.h \
+  $(SOPHYAINCP)pigraphx.h \
+  $(SOPHYAINCP)pigraphgen.h \
+  $(SOPHYAINCP)pifontx.h \
+  $(SOPHYAINCP)pifontgen.h \
+  $(SOPHYAINCP)pigrcoord.h \
+  $(SOPHYAINCP)pilineatt.h \
+  $(SOPHYAINCP)pigraphuc.h \
+  $(SOPHYAINCP)pievthandler.h \
+  $(SOPHYAINCP)psfile.h \
+  $(SOPHYAINCP)pigraphps.h \
+  $(SOPHYAINCP)piwindowx.h \
+  $(SOPHYAINCP)piwindowgen.h \
+  $(SOPHYAINCP)pioptmenux.h \
+  $(SOPHYAINCP)pioptmenugen.h \
+  $(SOPHYAINCP)pifilechox.h \
+  $(SOPHYAINCP)pifilechogen.h \
+  $(SOPHYAINCP)piperiodx.h \
+  $(SOPHYAINCP)periodic.h \
+  $(SOPHYAINCP)piimage.h \
+  $(SOPHYAINCP)parradapter.h \
+  $(SOPHYAINCP)lut.h \
+  $(SOPHYAINCP)pieldrw.h \
+  $(SOPHYAINCP)pidrawer.h \
+  $(SOPHYAINCP)pigratt.h \
+  $(SOPHYAINCP)piaxes.h \
+  $(SOPHYAINCP)pipixmapx.h \
+  $(SOPHYAINCP)pipixmapgen.h \
+  $(SOPHYAINCP)picmapview.h \
+  $(SOPHYAINCP)pi3dwdg.h \
+  $(SOPHYAINCP)pi3ddrw.h \
+  $(SOPHYAINCP)pigraph3d.h \
+  $(SOPHYAINCP)pisiadw.h \
+  $(SOPHYAINCP)pilistx.h \
+  $(SOPHYAINCP)pilistgen.h \
+  $(SOPHYAINCP)pistzwin.h \
+  $(SOPHYAINCP)pitherm.h \
+  $(SOPHYAINCP)resusage.h \
+  $(SOPHYAINCP)servnobjm.h \
+  $(SOPHYAINCP)nomgadapter.h \
+  $(SOPHYAINCP)ntupintf.h \
+  $(SOPHYAINCP)generalfit.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)generaldata.h \
+  $(SOPHYAINCP)poly.h \
+  $(SOPHYAINCP)peida.h \
+  $(SOPHYAINCP)utils.h \
+  $(SOPHYAINCP)perrors.h \
+  $(SOPHYAINCP)fmath.h \
+  $(SOPHYAINCP)ntuple.h \
+  $(SOPHYAINCP)slinparbuff.h \
+  $(SOPHYAINCP)localmap.h \
+  $(SOPHYAINCP)pixelmap.h \
+  $(SOPHYAINCP)spherepos.h \
+  $(SOPHYAINCP)unitvector.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)longlat.h \
+  $(SOPHYAINCP)utilgeom.h \
+  $(SOPHYAINCP)sphericalmap.h \
+  $(SOPHYAINCP)smathconst.h \
+  $(SOPHYAINCP)spherehealpix.h \
+  $(SOPHYAINCP)HEALPixUtils.h \
+  $(SOPHYAINCP)spherethetaphi.h \
+  $(SOPHYAINCP)sphericaltransformserver.h \
+  $(SOPHYAINCP)fftservintf.h \
+  $(SOPHYAINCP)fftpserver.h \
+  $(SOPHYAINCP)alm.h \
+  $(SOPHYAINCP)nbrandom.h \
+  $(SOPHYAINCP)srandgen.h \
+  $(SOPHYAINCP)nbmath.h \
+  $(SOPHYAINCP)triangmtx.h \
+  $(SOPHYAINCP)lambdaBuilder.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  skymapmodule.cc
+ 
+$(SOPHYAOBJP)sopiamodule.o: sopiamodule.cc \
+  $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)piacmd.h \
+  $(SOPHYAINCP)commander.h \
+  $(SOPHYAINCP)pdlmgr.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)ctimer.h \
+  $(SOPHYAINCP)zthread.h \
+  $(SOPHYAINCP)dlftypes.h \
+  $(SOPHYAINCP)nobjmgr.h \
+  $(SOPHYAINCP)pistdimgapp.h \
+  $(SOPHYAINCP)pisysdep.h \
+  $(SOPHYAINCP)piapplx.h \
+  $(SOPHYAINCP)piapplgen.h \
+  $(SOPHYAINCP)pimsghandler.h \
+  $(SOPHYAINCP)picontainerx.h \
+  $(SOPHYAINCP)picontainergen.h \
+  $(SOPHYAINCP)piwdgx.h \
+  $(SOPHYAINCP)piwdggen.h \
+  $(SOPHYAINCP)picolist.h \
+  $(SOPHYAINCP)pimenubarx.h \
+  $(SOPHYAINCP)pimenubargen.h \
+  $(SOPHYAINCP)pimenux.h \
+  $(SOPHYAINCP)pimenugen.h \
+  $(SOPHYAINCP)picons.h \
+  $(SOPHYAINCP)pistdwdgx.h \
+  $(SOPHYAINCP)pistdwdggen.h \
+  $(SOPHYAINCP)pibwdgx.h \
+  $(SOPHYAINCP)pibwdggen.h \
+  $(SOPHYAINCP)picmap.h \
+  $(SOPHYAINCP)picmapx.h \
+  $(SOPHYAINCP)picmapgen.h \
+  $(SOPHYAINCP)pigraphx.h \
+  $(SOPHYAINCP)pigraphgen.h \
+  $(SOPHYAINCP)pifontx.h \
+  $(SOPHYAINCP)pifontgen.h \
+  $(SOPHYAINCP)pigrcoord.h \
+  $(SOPHYAINCP)pilineatt.h \
+  $(SOPHYAINCP)pigraphuc.h \
+  $(SOPHYAINCP)pievthandler.h \
+  $(SOPHYAINCP)psfile.h \
+  $(SOPHYAINCP)pigraphps.h \
+  $(SOPHYAINCP)piwindowx.h \
+  $(SOPHYAINCP)piwindowgen.h \
+  $(SOPHYAINCP)pioptmenux.h \
+  $(SOPHYAINCP)pioptmenugen.h \
+  $(SOPHYAINCP)pifilechox.h \
+  $(SOPHYAINCP)pifilechogen.h \
+  $(SOPHYAINCP)piperiodx.h \
+  $(SOPHYAINCP)periodic.h \
+  $(SOPHYAINCP)piimage.h \
+  $(SOPHYAINCP)parradapter.h \
+  $(SOPHYAINCP)lut.h \
+  $(SOPHYAINCP)pieldrw.h \
+  $(SOPHYAINCP)pidrawer.h \
+  $(SOPHYAINCP)pigratt.h \
+  $(SOPHYAINCP)piaxes.h \
+  $(SOPHYAINCP)pipixmapx.h \
+  $(SOPHYAINCP)pipixmapgen.h \
+  $(SOPHYAINCP)picmapview.h \
+  $(SOPHYAINCP)pi3dwdg.h \
+  $(SOPHYAINCP)pi3ddrw.h \
+  $(SOPHYAINCP)pigraph3d.h \
+  $(SOPHYAINCP)pisiadw.h \
+  $(SOPHYAINCP)pilistx.h \
+  $(SOPHYAINCP)pilistgen.h \
+  $(SOPHYAINCP)pistzwin.h \
+  $(SOPHYAINCP)pitherm.h \
+  $(SOPHYAINCP)resusage.h \
+  $(SOPHYAINCP)servnobjm.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector_tsnl.h \
+  $(SOPHYAINCP)pitvmaad.h \
+  $(SOPHYAINCP)fftpserver.h \
+  $(SOPHYAINCP)fftservintf.h \
+  $(SOPHYAINCP)bruit.h \
+  $(SOPHYAINCP)piscdrawwdg.h \
+  $(SOPHYAINCP)nomgadapter.h \
+  $(SOPHYAINCP)ntupintf.h \
+  $(SOPHYAINCP)generalfit.h \
+  $(SOPHYAINCP)generaldata.h \
+  $(SOPHYAINCP)poly.h \
+  $(SOPHYAINCP)peida.h \
+  $(SOPHYAINCP)utils.h \
+  $(SOPHYAINCP)perrors.h \
+  $(SOPHYAINCP)fmath.h \
+  $(SOPHYAINCP)nomskymapadapter.h \
+  $(SOPHYAINCP)pixelmap.h \
+  $(SOPHYAINCP)spherepos.h \
+  $(SOPHYAINCP)unitvector.h \
+  $(SOPHYAINCP)vector3d.h \
+  $(SOPHYAINCP)longlat.h \
+  $(SOPHYAINCP)utilgeom.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  sopiamodule.cc
+ 
+$(SOPHYAOBJP)w2ps.o: w2ps.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)piacmd.h \
+  $(SOPHYAINCP)commander.h \
+  $(SOPHYAINCP)pdlmgr.h \
+  $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)ctimer.h \
+  $(SOPHYAINCP)zthread.h \
+  $(SOPHYAINCP)dlftypes.h \
+  $(SOPHYAINCP)nobjmgr.h \
+  $(SOPHYAINCP)pistdimgapp.h \
+  $(SOPHYAINCP)pisysdep.h \
+  $(SOPHYAINCP)piapplx.h \
+  $(SOPHYAINCP)piapplgen.h \
+  $(SOPHYAINCP)pimsghandler.h \
+  $(SOPHYAINCP)picontainerx.h \
+  $(SOPHYAINCP)picontainergen.h \
+  $(SOPHYAINCP)piwdgx.h \
+  $(SOPHYAINCP)piwdggen.h \
+  $(SOPHYAINCP)picolist.h \
+  $(SOPHYAINCP)pimenubarx.h \
+  $(SOPHYAINCP)pimenubargen.h \
+  $(SOPHYAINCP)pimenux.h \
+  $(SOPHYAINCP)pimenugen.h \
+  $(SOPHYAINCP)picons.h \
+  $(SOPHYAINCP)pistdwdgx.h \
+  $(SOPHYAINCP)pistdwdggen.h \
+  $(SOPHYAINCP)pibwdgx.h \
+  $(SOPHYAINCP)pibwdggen.h \
+  $(SOPHYAINCP)picmap.h \
+  $(SOPHYAINCP)picmapx.h \
+  $(SOPHYAINCP)picmapgen.h \
+  $(SOPHYAINCP)pigraphx.h \
+  $(SOPHYAINCP)pigraphgen.h \
+  $(SOPHYAINCP)pifontx.h \
+  $(SOPHYAINCP)pifontgen.h \
+  $(SOPHYAINCP)pigrcoord.h \
+  $(SOPHYAINCP)pilineatt.h \
+  $(SOPHYAINCP)pigraphuc.h \
+  $(SOPHYAINCP)pievthandler.h \
+  $(SOPHYAINCP)psfile.h \
+  $(SOPHYAINCP)pigraphps.h \
+  $(SOPHYAINCP)piwindowx.h \
+  $(SOPHYAINCP)piwindowgen.h \
+  $(SOPHYAINCP)pioptmenux.h \
+  $(SOPHYAINCP)pioptmenugen.h \
+  $(SOPHYAINCP)pifilechox.h \
+  $(SOPHYAINCP)pifilechogen.h \
+  $(SOPHYAINCP)piperiodx.h \
+  $(SOPHYAINCP)periodic.h \
+  $(SOPHYAINCP)piimage.h \
+  $(SOPHYAINCP)parradapter.h \
+  $(SOPHYAINCP)lut.h \
+  $(SOPHYAINCP)pieldrw.h \
+  $(SOPHYAINCP)pidrawer.h \
+  $(SOPHYAINCP)pigratt.h \
+  $(SOPHYAINCP)piaxes.h \
+  $(SOPHYAINCP)pipixmapx.h \
+  $(SOPHYAINCP)pipixmapgen.h \
+  $(SOPHYAINCP)picmapview.h \
+  $(SOPHYAINCP)pi3dwdg.h \
+  $(SOPHYAINCP)pi3ddrw.h \
+  $(SOPHYAINCP)pigraph3d.h \
+  $(SOPHYAINCP)pisiadw.h \
+  $(SOPHYAINCP)pilistx.h \
+  $(SOPHYAINCP)pilistgen.h \
+  $(SOPHYAINCP)pistzwin.h \
+  $(SOPHYAINCP)pitherm.h \
+  $(SOPHYAINCP)resusage.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  w2ps.cc
+ 